create or replace 
PROCEDURE ETL_PEDIDOS(P_DTINI  DATE,
                      P_DTFINA DATE)
IS
   --VARIAVEIS DE TEMPO
   V_MES           VARCHAR2(2);
   V_ANO           VARCHAR2(4);
   V_DTINI         DATE;
   V_DTFIM         DATE;
   V_DTFINA        DATE;
   V_DTINIEST      DATE;
   V_DTFIMEST      DATE;
   V_DTENTREGA     VARCHAR2(15);
   V_DIA           VARCHAR2(1);


   V_COMISSAO      NUMBER := 0;--FLAG PARA COMISSAO
   V_PRECOBASE     FLOAT(126);--PRECO BASE
   --IMPOSTO
   V_VRIMPACRES    FLOAT(126);--ACRESCE
   V_VRIMPDESC     FLOAT(126);--DESCONTA
   V_VRIMPDEST     FLOAT(126);--DESTACA
   V_VRIMPRETFONT  FLOAT(126);--RETIDO NA FONTE
   --ENCARGOS
   V_VRENCACRES    FLOAT(126);--ACRESCE
   V_VRENCDESC     FLOAT(126);--DESCONTA
   V_VRENCDEST     FLOAT(126);--DESTACA
   --TIPO DE CUSTO[1/2/3] DEFINIDO NA TELA DE PARAMETROS DE CUSTOS DO CVI
   V_VRTIPOCUSTO1  FLOAT(126);
   V_VRTIPOCUSTO2  FLOAT(126);
   V_VRTIPOCUSTO3  FLOAT(126);
   V_NRTIPOCUSTO1  NUMBER;
   V_NRTIPOCUSTO2  NUMBER;
   V_NRTIPOCUSTO3  NUMBER;
   V_NMTIPOCUSTO1  TIPOCUSTO.NMTIPOCUSTO%TYPE;
   V_NMTIPOCUSTO2  TIPOCUSTO.NMTIPOCUSTO%TYPE;
   V_NMTIPOCUSTO3  TIPOCUSTO.NMTIPOCUSTO%TYPE;
   --OUTRAS VARIAVEIS
   V_SITPED        VARCHAR2(30);  --SITUAO DO PEDIDO
   V_TIPPED        VARCHAR2(30);  --TIPO DE PEDIDO
   V_NMGRUPCLIE    VARCHAR2(100); --NOME DO GRUPO DE CLIENTE
   V_NMRAMOATV     VARCHAR2(100); --RAMO DE ATIVIDADE
   V_NMSEGMER      VARCHAR2(100); --NOME DO SEGMENTO DE MERCADO DO CLIENTE
   V_SGESTADO      VARCHAR2(15);  --SIGLA DO ESTADO
   V_NMMUNICIPIO   VARCHAR2(100); --NOME DO MUNICPIO
   V_NRNOTAFISC    VARCHAR2(14);  --NUMERO DA NOTA FISCAL
   V_NMTIPOOPER    VARCHAR2(30);  --TIPO DE OPERAO
   V_COUNTER       NUMBER  NOT NULL := 0;
   V_LINHA         NUMBER  NOT NULL := 0;
   V_ENCARGONF     NUMBER  NOT NULL := 0;--FLAG PARA ENCARGOS
   V_PEDIDOANT     NUMBER  NOT NULL := 0;
   
   V_QTITEMPED    FLOAT(126) NOT NULL :=0; 
   V_VRPEDIDO     FLOAT(126) NOT NULL :=0;   
   V_VRBRUTONF    FLOAT(126) NOT NULL :=0;
   V_VRDESC       FLOAT(126) NOT NULL :=0;

BEGIN
   V_DTINI := P_DTINI;
   V_DTFIM := P_DTFINA;
   V_MES := TO_CHAR(V_DTINI, 'MM');
   V_ANO := TO_CHAR(V_DTINI, 'YYYY');
   
 
   
   -->>DELEO DOS DADOS
      FOR C_DEL_PED IN (SELECT ROWID REG_DEL
                         FROM DM_PEDIDOS
                        WHERE TO_DATE(DTENTRETL,'DD/MM/YY') >= TO_DATE(V_DTINI,'DD/MM/YY') 
                      )LOOP

      V_COUNTER := V_COUNTER +1;

       DELETE
         FROM DM_PEDIDOS
        WHERE C_DEL_PED.REG_DEL = ROWID;

        IF V_COUNTER >= 1000 THEN
         COMMIT;
         V_COUNTER := 0;
        END IF;

     END LOOP;

 COMMIT;

  V_COUNTER := 0; 
   
   /* Seleciona 3 tipos de custo parametrizados  */
   FOR C_PRECUSTO IN (SELECT ROWNUM AS LINHA, NRTIPOCUSTO, NMTIPOCUSTO
                        FROM (SELECT TO_NUMBER(CDTIPOCUSTO) NRTIPOCUSTO, NMTIPOCUSTO
                                FROM TIPOCUSTO
                               WHERE IDTPCUSTOGSC = 'S'
                               ORDER BY NRTIPOCUSTO)
                      )LOOP
      IF C_PRECUSTO.LINHA    = 1 THEN
         V_NRTIPOCUSTO1    := C_PRECUSTO.NRTIPOCUSTO;
         V_NMTIPOCUSTO1    := C_PRECUSTO.NMTIPOCUSTO;
      ELSIF C_PRECUSTO.LINHA = 2 THEN
         V_NRTIPOCUSTO2    := C_PRECUSTO.NRTIPOCUSTO;
         V_NMTIPOCUSTO2    := C_PRECUSTO.NMTIPOCUSTO;
      ELSIF C_PRECUSTO.LINHA = 3 THEN
         V_NRTIPOCUSTO3    := C_PRECUSTO.NRTIPOCUSTO;
         V_NMTIPOCUSTO3    := C_PRECUSTO.NMTIPOCUSTO;
      END IF;
   END LOOP;

   WHILE (V_DTINI <= V_DTFIM) LOOP

      V_DTFINA := (V_DTINI);
      V_MES   := TO_CHAR(V_DTINI, 'MM');
      V_ANO   := TO_CHAR(V_DTINI, 'YYYY');
      V_DTINIEST := TO_DATE('01'||TO_CHAR(V_DTINI,'MMYYYY'),'DDMMYYYY');
      V_DTFIMEST := TO_DATE('01'||TO_CHAR(V_DTFINA,'MMYYYY'),'DDMMYYYY');

      --Dados de Pedidos
      FOR C_PED IN (SELECT CDFILIAL, CDCLIENTE,  CDVENDEDOR, DTENTPED,
                           NRPEDIDO, CDPRECOBASE, IDSITPEDIDO, IDTIPOPEDIDO,
                           (MODPGTO.DSMODPGTO||' A PARTIR DE: '||DTPEDIDO) DSPRAZO,
                           (CASE  
                              WHEN IDPGFRETTRAN='0' THEN 'EMITENTE(CIF)'
                              WHEN IDPGFRETTRAN='1' THEN 'DEST./REM.(FOB)'
                              WHEN IDPGFRETTRAN='2' THEN 'TERCEIROS'
                             ELSE 'SEM FRETE' END) DSTPFRETE
                      FROM PEDIDO, MODPGTO
                     WHERE DTPEDIDO BETWEEN V_DTINI AND V_DTFINA
                     AND PEDIDO.CDMODPGTO = MODPGTO.CDMODPGTO
                     ORDER BY CDCLIENTE, DTPEDIDO, NRPEDIDO, CDFILIAL
                    ) LOOP
                    
                    IF(V_PEDIDOANT <> C_PED.NRPEDIDO) THEN
                     V_PEDIDOANT := C_PED.NRPEDIDO;
                     V_ENCARGONF := 0;--grava encargo
                    ELSE 
                    V_ENCARGONF := 1;--no grava encargo                    
                    END IF;

            --Dados de Clientes
               --ESTADO E MUNICIPIO DO CLIENTE
               SELECT  SGE.SGESTADO, MUNICIPIO.NMMUNICIPIO
                 INTO  V_SGESTADO, V_NMMUNICIPIO
                 FROM
                      ((SELECT SGESTADO, CDMUNICIPIO
                          FROM ENDECLIE
                         WHERE ENDECLIE.CDCLIENTE = C_PED.CDCLIENTE
                           AND IDTPENDECLIE = 'T'--ENDEREO DE ENTREGA
                       )
                       UNION
                       (SELECT SGESTADO, CDMUNICIPIO
                          FROM ENDECLIE
                         WHERE ENDECLIE.CDCLIENTE = C_PED.CDCLIENTE
                           AND IDTPENDECLIE = 'P'--ENDEREO PRINCIPAL
                       )) SGE, MUNICIPIO
                WHERE ROWNUM = 1
                AND SGE.SGESTADO = MUNICIPIO.SGESTADO
                AND SGE.CDMUNICIPIO = MUNICIPIO.CDMUNICIPIO;

               --SEGMENTO DE MERCADO
               BEGIN
               SELECT SEGMERCADO.DSSEGMER
                 INTO V_NMSEGMER
                 FROM CLIENTE, SEGMERCADO
                WHERE CDCLIENTE = C_PED.CDCLIENTE
                  AND CLIENTE.CDSEGMER = SEGMERCADO.CDSEGMER;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_NMSEGMER := 'S/CADASTRO';
               END;

               --GRUPO DE CLIENTES
               BEGIN
               SELECT GRUPCLIE.NMGRUPCLIE NMGRUPCLIE
                 INTO V_NMGRUPCLIE
                 FROM CLIENTE, GRUPCLIE
                WHERE CDCLIENTE = C_PED.CDCLIENTE
                  AND CLIENTE.CDGRUPCLIE = GRUPCLIE.CDGRUPCLIE;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_NMGRUPCLIE := 'S/CADASTRO';
               END;

               --RAMO DE ATIVIDADE DO CLIENTE
               BEGIN
               SELECT ATIVCLIENTE.DSATIVCLI NMATIVCLIE
                 INTO V_NMRAMOATV
                 FROM CLIENTE, ATIVCLIENTE
                WHERE CDCLIENTE = C_PED.CDCLIENTE
                  AND CLIENTE.CDATIVCLI = ATIVCLIENTE.CDATIVCLI;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_NMRAMOATV := 'S/CADASTRO';
               END;
      --Dados dos tens de pedidos
      FOR C_ITEM IN
                   (SELECT ITEMPEDIDO.CDOPERADOR ,
                              ITEMPEDIDO.NRITEMPED,
                              NVL(I.NRLANCTONF,NULL) AS NRLANCTONF,
                              ITEMPEDIDO.CDPRODUTO,
                              ITEMPEDIDO.QTITEMPED    QTPED,
                              ITEMPEDIDO.VRPREUNITPED VRBRUTITEMPED,
                              ITEMPEDIDO.QTITEMPED * ITEMPEDIDO.VRPREUNITPED AS VRBRUTPED,
                              ITEMPEDIDO.VRDESITPED VRDESCPED,
                              NVL(DECODE(ITEMPEDIDO.IDSITITEMPED,'5',0,((ITEMPEDIDO.QTITEMPED * ITEMPEDIDO.VRPREUNITPED) - NVL(ITEMPEDIDO.VRDESITPED, 0))),0) AS VRLIQPED,
                             SUM((NVL(I.VRBRUTITEM,0))) AS VRBRUTONF,
                             NVL(DECODE(ITEMPEDIDO.IDSITITEMPED,'5',((ITEMPEDIDO.QTITEMPED * ITEMPEDIDO.VRPREUNITPED) - NVL(ITEMPEDIDO.VRDESITPED, 0)),0),0) AS VRITEMCANC,
                              ITEMPEDIDO.IDSITITEMPED IDSITITEMPED                              

                        FROM ITEMPEDIDO, ITEMPRODUTO I
                       WHERE ITEMPEDIDO.NRPEDIDO  = C_PED.NRPEDIDO
                         AND ITEMPEDIDO.CDFILIAL  = C_PED.CDFILIAL
                         AND ITEMPEDIDO.CDFILIAL  = I.CDFILIALPED(+)
                         AND ITEMPEDIDO.CDPRODUTO = I.CDPRODUTO(+)
                         AND ITEMPEDIDO.NRPEDIDO  = I.NRPEDIDO(+)
                         AND ITEMPEDIDO.NRITEMPED = I.NRITEMPED(+)
                       GROUP BY ITEMPEDIDO.CDPRODUTO, ITEMPEDIDO.CDOPERADOR, ITEMPEDIDO.VRPREUNITPED,ITEMPEDIDO.IDSITITEMPED,
                                ITEMPEDIDO.VRDESITPED, ITEMPEDIDO.QTITEMPED, ITEMPEDIDO.NRITEMPED,I.NRLANCTONF, I.CDFILIAL 
                      ORDER BY ITEMPEDIDO.NRITEMPED
            
                    ) LOOP

                    BEGIN
                      SELECT NVL(NRNOTAFISC,'NF NO EMITIDA'), NVL(TIPOOPERAC.NMTIPOOPER,'NF NO EMITIDA')
                        INTO V_NRNOTAFISC, V_NMTIPOOPER
                        FROM NOTAFISCAL, TIPOOPERAC
                       WHERE NOTAFISCAL.NRLANCTONF = C_ITEM.NRLANCTONF
                         AND NOTAFISCAL.CDFILIAL = C_PED.CDFILIAL
                         AND NOTAFISCAL.CDTIPOOPER = TIPOOPERAC.CDTIPOOPER
                         AND TIPOOPERAC.IDENTRSAIDOP = 'S';
                    EXCEPTION
                      WHEN NO_DATA_FOUND THEN
                      V_NRNOTAFISC := 'S/NF';
                      V_NMTIPOOPER := 'S/NF';
                    END;
                    
           --Preo base do tem do pedido
            BEGIN
               SELECT VRITEPREBASE
                 INTO V_PRECOBASE
                 FROM ITEMPREBASE
                WHERE CDPRODUTO = C_ITEM.CDPRODUTO
                  AND CDPRECOBASE = C_PED.CDPRECOBASE;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_PRECOBASE := 0;
            END;

   --IMPOSTOS E ENCARGOS DA NOTA FISCAL CASO EXISTA(REAL)
   IF(C_ITEM.NRLANCTONF IS NOT NULL) THEN
     
     --SOMATORIO DE IMPOSTOS PELO TIPO DE TRATAMENTO
     SELECT NVL(VRIMPACRES, 0)    VRIMPACRES,
              NVL(VRIMPDESC, 0)    VRIMPDESC,
              NVL(VRIMPDEST, 0)     VRIMPDEST,
              NVL(VRIMPRETFONT, 0)  VRIMPRETFONT
       
       INTO V_VRIMPACRES, V_VRIMPDESC, V_VRIMPDEST, V_VRIMPRETFONT
       
       FROM(--IMPOSTO QUE ACRESCE
            SELECT SUM(ITEMPROIMPOS.VRIMPOSTOIT) VRIMPACRES
            FROM ITEMPROIMPOS, IMPOSTO, (SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD
                                           FROM ITEMPRODUTO
                                          WHERE ITEMPRODUTO.CDFILIAL = C_PED.CDFILIAL
                                            AND ITEMPRODUTO.NRLANCTONF = C_ITEM.NRLANCTONF
                                            AND ITEMPRODUTO.CDPRODUTO = C_ITEM.CDPRODUTO) IT
            WHERE ITEMPROIMPOS.CDFILIAL = IT.CDFILIAL
              AND ITEMPROIMPOS.NRLANCTONF = IT.NRLANCTONF
              AND ITEMPROIMPOS.NRSEQITPROD = IT.NRSEQITPROD
              AND ITEMPROIMPOS.CDIMPOSTO = IMPOSTO.CDIMPOSTO
              AND IMPOSTO.IDTRATIMPO      = 'A'),
            
            (--IMPOSTO QUE DESCONTA
            SELECT SUM(ITEMPROIMPOS.VRIMPOSTOIT) VRIMPDESC
            FROM ITEMPROIMPOS, IMPOSTO, (SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD
                                           FROM ITEMPRODUTO
                                          WHERE ITEMPRODUTO.CDFILIAL = C_PED.CDFILIAL
                                            AND ITEMPRODUTO.NRLANCTONF = C_ITEM.NRLANCTONF
                                            AND ITEMPRODUTO.CDPRODUTO = C_ITEM.CDPRODUTO) IT
            WHERE ITEMPROIMPOS.CDFILIAL = IT.CDFILIAL
              AND ITEMPROIMPOS.NRLANCTONF = IT.NRLANCTONF
              AND ITEMPROIMPOS.NRSEQITPROD = IT.NRSEQITPROD
              AND ITEMPROIMPOS.CDIMPOSTO = IMPOSTO.CDIMPOSTO
              AND IMPOSTO.IDTRATIMPO      =  'D'),
            
            (--IMPOSTO QUE DESTACA
            SELECT SUM(ITEMPROIMPOS.VRIMPOSTOIT) VRIMPDEST
            FROM ITEMPROIMPOS, IMPOSTO, (SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD
                                           FROM ITEMPRODUTO
                                          WHERE ITEMPRODUTO.CDFILIAL = C_PED.CDFILIAL
                                            AND ITEMPRODUTO.NRLANCTONF = C_ITEM.NRLANCTONF
                                            AND ITEMPRODUTO.CDPRODUTO = C_ITEM.CDPRODUTO) IT
            WHERE ITEMPROIMPOS.CDFILIAL = IT.CDFILIAL
              AND ITEMPROIMPOS.NRLANCTONF = IT.NRLANCTONF
              AND ITEMPROIMPOS.NRSEQITPROD = IT.NRSEQITPROD
              AND ITEMPROIMPOS.CDIMPOSTO = IMPOSTO.CDIMPOSTO
              AND IMPOSTO.IDTRATIMPO      =  'V'),
            
            (--IMPOSTO QUE RETEM NA FONTE
            SELECT SUM(ITEMPROIMPOS.VRIMPOSTOIT) VRIMPRETFONT
            FROM ITEMPROIMPOS, IMPOSTO, (SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD
                                           FROM ITEMPRODUTO
                                          WHERE ITEMPRODUTO.CDFILIAL = C_PED.CDFILIAL
                                            AND ITEMPRODUTO.NRLANCTONF = C_ITEM.NRLANCTONF
                                            AND ITEMPRODUTO.CDPRODUTO = C_ITEM.CDPRODUTO) IT
            WHERE ITEMPROIMPOS.CDFILIAL = IT.CDFILIAL
              AND ITEMPROIMPOS.NRLANCTONF = IT.NRLANCTONF
              AND ITEMPROIMPOS.NRSEQITPROD = IT.NRSEQITPROD
              AND ITEMPROIMPOS.CDIMPOSTO = IMPOSTO.CDIMPOSTO
              AND IMPOSTO.IDTRATIMPO      =  'R');
     
     --SOMATORIO DE ENCARGOS PELO TIPO DE TRATAMENTO
     SELECT NVL(VRENCACRES,0) VRENCACRES,
             NVL(VRENCDESC,0)  VRENCDESC,
             NVL(VRENCDEST,0)  VRENCDEST

     INTO V_VRENCACRES, V_VRENCDESC, V_VRENCDEST

     FROM
          (--ENCARGOS QUE ACRESCEM
          SELECT SUM(ITEMENCARGO.VRITEMENCA) VRENCACRES
           FROM ITEMENCARGO , ENCARGO
          WHERE ITEMENCARGO.NRLANCTONF = C_ITEM.NRLANCTONF
            AND ITEMENCARGO.CDFILIAL     = C_PED.CDFILIAL
            AND ENCARGO.CDENCARGO        = ITEMENCARGO.CDENCARGO
            AND IDENCARGO                ='A'
          ),
          (--ENCARGOS QUE DESCONTAM
          SELECT SUM(ITEMENCARGO.VRITEMENCA) VRENCDESC
           FROM ITEMENCARGO , ENCARGO
          WHERE ITEMENCARGO.NRLANCTONF = C_ITEM.NRLANCTONF
            AND ITEMENCARGO.CDFILIAL     = C_PED.CDFILIAL
            AND ENCARGO.CDENCARGO        = ITEMENCARGO.CDENCARGO
            AND IDENCARGO                ='D'
          ),
          (--ENCARGOS QUE DESTACAM
          SELECT SUM(ITEMENCARGO.VRITEMENCA) VRENCDEST
            FROM ITEMENCARGO , ENCARGO
          WHERE ITEMENCARGO.NRLANCTONF = C_ITEM.NRLANCTONF
            AND ITEMENCARGO.CDFILIAL     = C_PED.CDFILIAL
            AND ENCARGO.CDENCARGO        = ITEMENCARGO.CDENCARGO
            AND IDENCARGO                ='V'
          );

   --CASO NO EXISTA NOTA FISCAL IMPOSTOS E ENCARGOS DA NOTA FICAM ZERADOS
   ELSE
                 V_VRIMPACRES    := 0;
                 V_VRIMPDESC     := 0;
                 V_VRIMPDEST     := 0;
                 V_VRIMPRETFONT  := 0;
                 V_VRENCACRES    := 0;
                 V_VRENCDESC     := 0;
                 V_VRENCDEST     := 0;
   END IF;

            
            V_VRTIPOCUSTO1 := CUSTO_PRODUTO(C_PED.CDFILIAL, C_ITEM.CDPRODUTO, V_NRTIPOCUSTO1, TO_DATE(V_DTFIMEST), TRUNC(SYSDATE));
            V_VRTIPOCUSTO2 := CUSTO_PRODUTO(C_PED.CDFILIAL, C_ITEM.CDPRODUTO, V_NRTIPOCUSTO2, TO_DATE(V_DTFIMEST), TRUNC(SYSDATE));
            V_VRTIPOCUSTO3 := CUSTO_PRODUTO(C_PED.CDFILIAL, C_ITEM.CDPRODUTO, V_NRTIPOCUSTO3, TO_DATE(V_DTFIMEST), TRUNC(SYSDATE));


        --VERIFICAO DA SITUAO/TIPO DO PEDIDO
        CASE C_PED.IDSITPEDIDO
            WHEN '1' THEN V_SITPED := 'Pendente';
            WHEN '2' THEN V_SITPED := 'Em Andamento';
            WHEN '3' THEN V_SITPED := 'Liquidado';
            WHEN '4' THEN V_SITPED := 'Cancelado';
            WHEN '5' THEN V_SITPED := 'Liq. Forc.';
           ELSE V_SITPED := 'Parc. Atendido';
        END CASE;


        CASE C_PED.IDTIPOPEDIDO
           WHEN '1' THEN V_TIPPED := 'Pedido';
          ELSE V_TIPPED := 'Oramento';
        END CASE;
        
        V_DIA := TO_CHAR(C_PED.DTENTPED, 'D');
        
         CASE V_DIA
                         WHEN  '1' THEN V_DTENTREGA := (TO_CHAR(C_PED.DTENTPED,'DD/MM/YY') || ' - DOM');
                         WHEN  '2' THEN V_DTENTREGA := (TO_CHAR(C_PED.DTENTPED,'DD/MM/YY') || ' - SEG');
                         WHEN  '3' THEN V_DTENTREGA := (TO_CHAR(C_PED.DTENTPED,'DD/MM/YY') || ' - TER');
                         WHEN  '4' THEN V_DTENTREGA := (TO_CHAR(C_PED.DTENTPED,'DD/MM/YY') || ' - QUA');
                         WHEN  '5' THEN V_DTENTREGA := (TO_CHAR(C_PED.DTENTPED,'DD/MM/YY') || ' - QUI');
                         WHEN  '6' THEN V_DTENTREGA := (TO_CHAR(C_PED.DTENTPED,'DD/MM/YY') || ' - SEX');
                         WHEN  '7' THEN V_DTENTREGA := (TO_CHAR(C_PED.DTENTPED,'DD/MM/YY') || ' - SAB');
         END CASE;

      SELECT COUNT(*)
        INTO V_COMISSAO
        FROM VENDITEMPED
       WHERE NRPEDIDO = C_PED.NRPEDIDO
         AND CDFILIAL = C_PED.CDFILIAL
         AND NRITEMPED = C_ITEM.NRITEMPED;

      IF(V_COMISSAO <> 0) THEN
      --Dados de Comisso de Vendedor
      
      FOR C_COMISSAO IN(
                          SELECT DECODE(VENDITEMPED.CDVENDEDOR,NULL,'S/CADASTRO',VENDEDOR.NMFANVEN) NMVENDEDOR,
                                   ((VRPECOMITPED/100) * C_ITEM.VRLIQPED) VRCOMISSAO
                              FROM VENDITEMPED, VENDEDOR
                             WHERE VENDITEMPED.CDVENDEDOR = VENDEDOR.CDVENDEDOR
                               AND VENDITEMPED.NRPEDIDO   = C_PED.NRPEDIDO
                               AND VENDITEMPED.CDFILIAL   = C_PED.CDFILIAL
                               AND VENDITEMPED.NRITEMPED  = C_ITEM.NRITEMPED

                       ) LOOP
                       

					   SELECT COUNT(*)
                         INTO V_LINHA					   
					     FROM DM_PEDIDOS
						WHERE DM_PEDIDOS.NRETLPEDIDO = C_PED.NRPEDIDO
						  AND DM_PEDIDOS.CDFILIAL    = C_PED.CDFILIAL
						  AND DM_PEDIDOS.CDPRODUTO   = C_ITEM.CDPRODUTO
              AND DM_PEDIDOS.VRLIQPED    = C_ITEM.VRLIQPED;
					

        INSERT INTO DM_PEDIDOS
            (
               --DIMENSES--
                CDANOBI          , --ANO
                CDMESBI          , --MES
                CDFILIAL         , --CODIGO DA FILIAL
                DTENTRETL        , --USO DA ETL
                DTENTRPED        , --DATA ENTREGA DO PEDIDO
                CDOPERADOR       , --OPERADOR DE INCLUSO DO PEDIDO
                DSTPOPERANF      , --TIPO DE OPERACAO DA NOTA FISCAL
                DSPRAZO          , --PRAZO DE PAGAMENTO DO PEDIDO
                DSTPFRETE        , --DESCRICAO DO TIPO DE FRETE DO PEDIDO
                NRETLPEDIDO      , --NUMERO DO PEDIDO
                NRNOTAFISC       , --NUMERO DA NOTA FISCAL
                DSSITPED         , --SITUACAO DO PEDIDO
                DSTIPOPED        , --TIPO DE PEDIDO
                CDVENDEDOR       , --VENDEDOR DO PEDIDO
                NMVENDECOMI      , --VENDEDOR DA COMISSAO
                CDCLIENTE        , --CDIGO DO CLIENTE
                NMGRUPCLIE       , --GRUPO DO CLIENTE
                NMSEGMER         , --SEGMENTO DE MERCADO DO CLIENTE
                NMRAMOATV        , --RAMO DE ATIVIDADE DO CLIENTE
                SGESTADO         , --ESTADO DO CLIENTE
                NMMUNICIPIO      , --MUNICIPIO DO CLIENTE
                CDPRODUTO        , --ITEM DO PEDIDO
                --FATOS--
                VRCUS1           , --Custo de Estoque 1
                VRCUS2           , --Custo de Estoque 2
                VRCUS3           , --Custo de Estoque 3
                VRPRECOBASE      , --PreCo base
                QTITEM           , --Quantidade
                VRLIQPED         , --Valor do Pedido/Item(LIQUIDO)
                VRBRUTPED        , --Valor do Pedido/Item(BRUTO)
                VRLIQNF          , --Valor bruto da nota fiscal
                VRIMPACRES       , --Valor de Imposto que acrescem
                VRIMPDESC        , --Valor de Imposto que desconta
                VRIMPDEST        , --Valor de Imposto que destaca
                VRIMPRETFON      , --Valor de Imposto que retem na fonte
                VRDESCITEM       , --Valor do desconto do item
                VRENCACRES       , --Valor dos encargos que  acrescem
                VRENCDESC        , --Valor dos encargos que descontam
                VRENCDEST        , --Valor dos encargos que destacam
                VRCOMISSAO       , --Valor da Comisso REAL
                VRCOMISPRE         --Valor da Comisso PREVISTA
            )
            VALUES
            (
               --DIMENSES--
               V_ANO,                   --ANO
               V_MES,                   --MES
               C_PED.CDFILIAL,          --CDIGO DA FILIAL
               TO_DATE(C_PED.DTENTPED,'DD/MM/YYYY'),          --USO DA ETL
               V_DTENTREGA,             --DATA ENTREGA DO PEDIDO
               C_ITEM.CDOPERADOR,       --OPERADOR DE INCLUSAO DO PEDIDO
               V_NMTIPOOPER,            --TIPO DE OPERACAO DA NF
               C_PED.DSPRAZO,           --PRAZO DE PAGAMENTO DO PEDIDO
               C_PED.DSTPFRETE,         --DESCRICAO DO TIPO DE FRETE DO PEDIDO
               C_PED.NRPEDIDO,          --NUMERO DO PEDIDO
               V_NRNOTAFISC,            --NUMERO DA NOTA FISCAL
               V_SITPED,                --SITUAO DO PEDIDO
               V_TIPPED,                --TIPO DE PEDIDO
               C_PED.CDVENDEDOR,        --VENDEDOR DO PEDIDO
               C_COMISSAO.NMVENDEDOR,   --VENDEDOR DA COMISSAO
               C_PED.CDCLIENTE,         --CDIGO DO CLIENTE
               V_NMGRUPCLIE,            --GRUPO DO CLIENTE
               V_NMSEGMER,              --SEGMENTO DE MERCADO DO CLIENTE
               V_NMRAMOATV,             --RAMO DE ATIVIDADE DO CLIENTE
               V_SGESTADO,              --SIGLA DO ESTADO DO CLIENTE
               V_NMMUNICIPIO,           --MUNICIPIO DO CLIENTE
               C_ITEM.CDPRODUTO,        --ITEM DO PEDIDO
               --FATOS--
               DECODE(V_LINHA,0,V_VRTIPOCUSTO1,0),          --Custo de Estoque 1
               DECODE(V_LINHA,0,V_VRTIPOCUSTO1,0),          --Custo de Estoque 2
               DECODE(V_LINHA,0,V_VRTIPOCUSTO1,0),          --Custo de Estoque 3
               DECODE(V_LINHA,0,V_PRECOBASE,0),             --Preo base
               DECODE(V_LINHA,0,C_ITEM.QTPED,0),            --Quantidade
               DECODE(V_LINHA,0,DECODE(C_PED.IDSITPEDIDO,'4',C_ITEM.VRITEMCANC,C_ITEM.VRLIQPED),0),         --Valor do Pedido/Item(LIQUIDO)
               DECODE(V_LINHA,0,DECODE(C_PED.IDSITPEDIDO,'4',C_ITEM.VRITEMCANC,C_ITEM.VRBRUTPED),0),         --Valor do Pedido/Item(BRUTO)
               DECODE(V_LINHA,0,C_ITEM.VRBRUTONF,0),        --Valor bruto da nota fiscal
               DECODE(V_LINHA,0,V_VRIMPACRES,0),            --Valor de Imposto que acrescem
               DECODE(V_LINHA,0,V_VRIMPDESC,0),             --Valor de Imposto que desconta
               DECODE(V_LINHA,0,V_VRIMPDEST,0),             --Valor de Imposto que destaca
               DECODE(V_LINHA,0,V_VRIMPRETFONT,0),          --Valor de Imposto que retem na fonte
               DECODE(V_LINHA,0,C_ITEM.VRDESCPED,0),           --Valor do desconto do item
               DECODE(V_LINHA,0,DECODE(V_ENCARGONF,0,V_VRENCACRES,0),0),            --Valor de encargo que acresce
               DECODE(V_LINHA,0,DECODE(V_ENCARGONF,0,V_VRENCDESC,0),0),             --Valor de encargo que desconta
               DECODE(V_LINHA,0,DECODE(V_ENCARGONF,0,V_VRENCDEST,0),0),             --Valor de encargo que destaca
               DECODE(C_ITEM.IDSITITEMPED,'4',C_COMISSAO.VRCOMISSAO,0),   --Valor da Comissao REAL
               DECODE(C_ITEM.IDSITITEMPED,'4',0,C_COMISSAO.VRCOMISSAO)   --Valor da Comissao PREVISTA
            );
            COMMIT;
           END LOOP;/*FIM DO LOOP DE COMISSO*/
		
		V_LINHA := 0;

        ELSE

        INSERT INTO DM_PEDIDOS
            (
               --DIMENSES--
                CDANOBI          , --ANO
                CDMESBI          , --MES
                CDFILIAL         , --CODIGO DA FILIAL
                DTENTRETL        , --USO DA ETL
                DTENTRPED        , --DATA ENTREGA DO PEDIDO
                CDOPERADOR       , --OPERADOR DE INCLUSAO DO PEDIDO
                DSTPOPERANF      , --TIPO DE OPERACAO DA NOTA FISCAL
                DSPRAZO          , --PRAZO DE PAGAMENTO DO PEDIDO
                DSTPFRETE        , --DESCRICAO DO TIPO DE FRETE DO PEDIDO
                NRETLPEDIDO      , --NUMERO DO PEDIDO
                NRNOTAFISC       , --NUMERO DA NOTA FISCAL
                DSSITPED         , --SITUCAO DO PEDIDO
                DSTIPOPED        , --TIPO DE PEDIDO
                CDVENDEDOR       , --VENDEDOR DO PEDIDO
                NMVENDECOMI      , --VENDEDOR DA COMISSAO
                CDCLIENTE        , --CODIGO DO CLIENTE
                NMGRUPCLIE       , --GRUPO DO CLIENTE
                NMSEGMER         , --SEGMENTO DE MERCADO DO CLIENTE
                NMRAMOATV        , --RAMO DE ATIVIDADE DO CLIENTE
                SGESTADO         , --ESTADO DO CLIENTE
                NMMUNICIPIO      , --MUNICIPIO DO CLIENTE
                CDPRODUTO        , --ITEM DO PEDIDO
                --FATOS--
                VRCUS1           , --Custo de Estoque 1
                VRCUS2           , --Custo de Estoque 2
                VRCUS3           , --Custo de Estoque 3
                VRPRECOBASE      , --Preco base
                QTITEM           , --Quantidade
                VRLIQPED        , --Valor do Pedido/Item(LIQUIDO)
                VRBRUTPED        , --Valor do Pedido/Item(BRUTO)
                VRLIQNF        , --Valor bruto da nota fiscal
                VRIMPACRES       , --Valor de Imposto que acrescem
                VRIMPDESC        , --Valor de Imposto que desconta
                VRIMPDEST        , --Valor de Imposto que destaca
                VRIMPRETFON      , --Valor de Imposto que retem na fonte
                VRDESCITEM       , --Valor do desconto do item
                VRENCACRES       , --Valor dos encargos que  acrescem
                VRENCDESC        , --Valor dos encargos que descontam
                VRENCDEST        , --Valor dos encargos que destacam
                VRCOMISSAO       , --Valor da Comissao REAL
                VRCOMISPRE         --VALOR DA COMISSAO PREVISTA
            )
            VALUES
            (
               --DIMENSES--
               V_ANO,                   --ANO
               V_MES,                   --MES
               C_PED.CDFILIAL,          --CODIGO DA FILIAL
               TO_DATE(C_PED.DTENTPED,'DD/MM/YYYY'),          --USO DA ETL
               V_DTENTREGA,             --DATA DE ENTREGA DO PEDIDO
               C_ITEM.CDOPERADOR,       --OPERADOR DE INCLUSAO DO PEDIDO
               V_NMTIPOOPER,            --TIPO DE OPERACAO DA NF
               C_PED.DSPRAZO,           --PRAZO DE PAGAMENTO DO PEDIDO
               C_PED.DSTPFRETE,           --DESCRICAO DO TIPO DE FRETE DO PEDIDO
               C_PED.NRPEDIDO,          --NUMERO DO PEDIDO
               V_NRNOTAFISC,            --NUMERO DA NOTA FISCAL
               V_SITPED,                --SITUACAO DO PEDIDO
               V_TIPPED,                --TIPO DE PEDIDO
               C_PED.CDVENDEDOR,        --VENDEDOR DO PEDIDO
               'S/CADASTRO',            --VENDEDOR DA COMISSAO
               C_PED.CDCLIENTE,         --CODIGO DO CLIENTE
               V_NMGRUPCLIE,            --GRUPO DO CLIENTE
               V_NMSEGMER,              --SEGMENTO DE MERCADO DO CLIENTE
               V_NMRAMOATV,             --RAMO DE ATIVIDADE DO CLIENTE
               V_SGESTADO,              --SIGLA DO ESTADO DO CLIENTE
               V_NMMUNICIPIO,           --MUNICIPIO DO CLIENTE
               C_ITEM.CDPRODUTO,        --ITEM DO PEDIDO
               --FATOS--
               V_VRTIPOCUSTO1,          --Custo de Estoque 1
               V_VRTIPOCUSTO2,          --Custo de Estoque 2
               V_VRTIPOCUSTO3,          --Custo de Estoque 3
               V_PRECOBASE,             --PreCo base
               C_ITEM.QTPED,           --Quantidade
               DECODE(C_PED.IDSITPEDIDO,'4',C_ITEM.VRITEMCANC,C_ITEM.VRLIQPED), --Valor do Pedido/Item(LIQUIDO)
               DECODE(C_PED.IDSITPEDIDO,'4',C_ITEM.VRITEMCANC,C_ITEM.VRBRUTPED),--Valor do Pedido/Item(BRUTO)
               C_ITEM.VRBRUTONF,        --Valor bruto da nota fiscal
               V_VRIMPACRES,            --Valor de Imposto que acrescem
               V_VRIMPDESC,             --Valor de Imposto que desconta
               V_VRIMPDEST,             --Valor de Imposto que destaca
               V_VRIMPRETFONT,          --Valor de Imposto que retem na fonte
               C_ITEM.VRDESCPED,           --Valor do desconto do Item
               DECODE(V_ENCARGONF,0,V_VRENCACRES,0),            --Valor de encargo que acresce
               DECODE(V_ENCARGONF,0,V_VRENCDESC,0),             --Valor de encargo que desconta
               DECODE(V_ENCARGONF,0,V_VRENCDEST,0),             --Valor de encargo que destaca
               0,                       --Valor da Comissao REAL
               0                        --VALOR DA COMISSAO PREVISTA
            );
           COMMIT;
           
         END IF;
        commit;
         END LOOP; /*FIM LOOP CURSO DE ITEM DO PEDIDO*/
         COMMIT;
      END LOOP;  /*FIM LOOP CURSO DE PEDIDO*/
         COMMIT;
      V_DTINI := (V_DTINI+1);
      COMMIT;
   END LOOP; /*FIM LOOP WHILE*/
     commit;
END;

/
DECLARE
V_EXISTE NUMBER :=0;
BEGIN
   
   SELECT COUNT(*)
     INTO V_EXISTE
     FROM TABELADW 
    WHERE CDTABELADW = 'DM_PEDIDOS';
    
    IF(V_EXISTE = 0) THEN
    INSERT INTO TABELADW (CDTABELADW, NMTABELADW, IDDRILLDOWN) VALUES ('DM_PEDIDOS','Pedidos','N');

    CRIA_FATOS ('DM_PEDIDOS', 'VRLIQPED',          'Vr. Lq. Ped.',           'Valor Lquido do Pedido',                         'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRBRUTPED',         'Vr. Orig. do Ped.',       'Valor Bruto do Pedido',                           'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRLIQNF',           'Vr. Brut. NF',            'Valor bruto da nota fiscal',                      'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRCOMISSAO',        'Vr. Comisso',            'Valor da Comisso do Vendedor',                   'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRCOMISPRE',        'Vr. Comis. Prev.',        'Valor da Comisso do Vendedor',                   'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRPRECOBASE',       'Preo base',              'Preo base do tem',                              'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRIMPACRES',        'Vr. Imp. Acres.',         'Valor dos Impostos que Acrescem o valor da NF',   'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRIMPDESC',         'Vr. Imp. Desc.',          'Valor dos Impostos que Desconta no valor da NF',  'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRIMPDEST',         'Vr. Imp. Dest.',          'Valor dos Impostos que Destaca no valor da NF',   'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRIMPRETFON',       'Vr. Imp. Ret. na Fonte',  'Valor dos Impostos Retido na Fonte',              'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRENCACRES',        'Vr. Enc. Acres.',         'Valor dos Encargos que Acrescem o valor da NF',   'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRENCDESC',         'Vr. Enc. Desc.',          'Valor dos Encargos que Descontam no valor da NF', 'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRENCDEST',         'Vr. Enc. Dest.',          'Valor dos Encargos que Destaca no valor da NF',   'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRDESCITEM',        'Vr. Desc. do Pedido',     'Valor dos Descontos dos tens do pedido',         'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRCUS1',            'Cust. de Estoque 1',      'Primeiro custo parametrizado',                    'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRCUS2',            'Cust. de Estoque 2',      'Segundo custo parametrizado',                     'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRCUS3',            'Cust. de Estoque 3',      'Terceiro custo parametrizado',                    'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'QTITEM',            'Quantidade',              'Quantidade do tem do pedido',                    'Pedido');
    
    
    CRIA_DIME ('DM_PEDIDOS',  'CDFILIAL',    'Filial',                'FILIAL',   'CDFILIAL',      'NMFILIAL',       '');
    CRIA_DIME ('DM_PEDIDOS',  'CDCLIENTE',   'Cliente',               'CLIENTE',  'CDCLIENTE',     'NMFANTCLIE',     '');
    CRIA_DIME ('DM_PEDIDOS',  'CDOPERADOR',  'Oper. de Inclu.',       'OPERADOR', 'CDOPERADOR',    'NMOPERADOR',     '');
    CRIA_DIME ('DM_PEDIDOS',  'CDPRODUTO',   'tem do Ped.',          'PRODUTO',  'CDPRODUTO',     'NMPRODUTO',      '');
    CRIA_DIME ('DM_PEDIDOS',  'CDVENDEDOR',  'Vendedor',              'VENDEDOR',  'CDVENDEDOR',   'NMFANVEN',       '');
    CRIA_DIME ('DM_PEDIDOS',  'NMVENDECOMI', 'Vend. da Comisso',      NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'CDANOBI',     'Ano',                    NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'CDMESBI',     'Ms',                    NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'NRETLPEDIDO', 'Nr. do Pedido.',         NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'DTENTRPED',   'Entrega do Ped.',        NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'NMSEGMER',    'Seg. do Cliente',        NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'NMRAMOATV',   'Ramo de Ativ.',          NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'NMGRUPCLIE',  'Grup. do Cliente',       NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'NMMUNICIPIO', 'Municpio',              NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'SGESTADO',    'Estado',                 NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'NRNOTAFISC',  'Nr. NF',                 NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'DSSITPED',    'Sit. Ped.',              NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'DSTIPOPED',   'Tip. Ped.',              NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'DSTPFRETE',   'Tip. Frete',             NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'DSPRAZO',     'Prazo',                  NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'DSTPOPERANF', 'Tip. Operac.',           NULL,       NULL,           NULL,         NULL);
    
    ELSE
    CRIA_FATOS ('DM_PEDIDOS', 'VRLIQPED',          'Vr. Lq. Ped.',           'Valor Lquido do Pedido',                         'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRBRUTPED',         'Vr. Orig. do Ped.',       'Valor Bruto do Pedido',                           'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRLIQNF',           'Vr. Brut. NF',            'Valor bruto da nota fiscal',                      'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRCOMISSAO',        'Vr. Comisso',            'Valor da Comisso do Vendedor',                   'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRCOMISPRE',        'Vr. Comis. Prev.',        'Valor da Comisso do Vendedor',                   'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRPRECOBASE',       'Preo base',              'Preo base do tem',                              'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRIMPACRES',        'Vr. Imp. Acres.',         'Valor dos Impostos que Acrescem o valor da NF',   'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRIMPDESC',         'Vr. Imp. Desc.',          'Valor dos Impostos que Desconta no valor da NF',  'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRIMPDEST',         'Vr. Imp. Dest.',          'Valor dos Impostos que Destaca no valor da NF',   'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRIMPRETFON',       'Vr. Imp. Ret. na Fonte',  'Valor dos Impostos Retido na Fonte',              'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRENCACRES',        'Vr. Enc. Acres.',         'Valor dos Encargos que Acrescem o valor da NF',   'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRENCDESC',         'Vr. Enc. Desc.',          'Valor dos Encargos que Descontam no valor da NF', 'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRENCDEST',         'Vr. Enc. Dest.',          'Valor dos Encargos que Destaca no valor da NF',   'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRDESCITEM',        'Vr. Desc. do Pedido',     'Valor dos Descontos dos tens do pedido',         'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRCUS1',            'Cust. de Estoque 1',      'Primeiro custo parametrizado',                    'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRCUS2',            'Cust. de Estoque 2',      'Segundo custo parametrizado',                     'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'VRCUS3',            'Cust. de Estoque 3',      'Terceiro custo parametrizado',                    'Pedido');
    CRIA_FATOS ('DM_PEDIDOS', 'QTITEM',            'Quantidade',              'Quantidade do tem do pedido',                    'Pedido');
    
    
    CRIA_DIME ('DM_PEDIDOS',  'CDFILIAL',    'Filial',                'FILIAL',   'CDFILIAL',      'NMFILIAL',       '');
    CRIA_DIME ('DM_PEDIDOS',  'CDCLIENTE',   'Cliente',               'CLIENTE',  'CDCLIENTE',     'NMFANTCLIE',     '');
    CRIA_DIME ('DM_PEDIDOS',  'CDOPERADOR',  'Oper. de Inclu.',       'OPERADOR', 'CDOPERADOR',    'NMOPERADOR',     '');
    CRIA_DIME ('DM_PEDIDOS',  'CDPRODUTO',   'tem do Ped.',          'PRODUTO',  'CDPRODUTO',     'NMPRODUTO',      '');
    CRIA_DIME ('DM_PEDIDOS',  'CDVENDEDOR',  'Vendedor',              'VENDEDOR',  'CDVENDEDOR',   'NMFANVEN',       '');
    CRIA_DIME ('DM_PEDIDOS',  'NMVENDECOMI', 'Vend. da Comisso',      NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'CDANOBI',     'Ano',                    NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'CDMESBI',     'Ms',                    NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'NRETLPEDIDO', 'Nr. do Pedido.',         NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'DTENTRPED',   'Entrega do Ped.',        NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'NMSEGMER',    'Seg. do Cliente',        NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'NMRAMOATV',   'Ramo de Ativ.',          NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'NMGRUPCLIE',  'Grup. do Cliente',       NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'NMMUNICIPIO', 'Municpio',              NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'SGESTADO',    'Estado',                 NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'NRNOTAFISC',  'Nr. NF',                 NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'DSSITPED',    'Sit. Ped.',              NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'DSTIPOPED',   'Tip. Ped.',              NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'DSTPFRETE',   'Tip. Frete',             NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'DSPRAZO',     'Prazo',                  NULL,       NULL,           NULL,         NULL);
    CRIA_DIME ('DM_PEDIDOS',  'DSTPOPERANF', 'Tip. Operac.',           NULL,       NULL,           NULL,         NULL);
    END IF;
END;

/

DECLARE
   V_CDSEQUENCIAL VARCHAR2(20) NULL;
BEGIN
    /*REGISTRANDO A PROCEDURE PARA O AGENDADOR DE EVENTOS*/
    SELECT COUNT(*)
    INTO   V_CDSEQUENCIAL
    FROM   EVENTOAEV 
    WHERE  NMOBJBDEVEN = 'ETL_PEDIDOS';
    
    IF V_CDSEQUENCIAL = 0 THEN
        BEGIN
        
            SELECT LPAD(NVL(MAX(LPAD(CDEVENTOAEV, 10, 0))+1,0),10,'0')
            INTO   V_CDSEQUENCIAL
            FROM   EVENTOAEV;
        
            INSERT INTO EVENTOAEV 
            (CDEVENTOAEV, NMEVENTOAEV, IDTPEVENAEV, CDOPERINCL, DTINCLEVEN, NMOBJBDEVEN)
            VALUES
            (V_CDSEQUENCIAL,'ETL Pedidos','STP', NULL, SYSDATE, 'ETL_PEDIDOS');
            COMMIT;
            
        EXCEPTION
           WHEN OTHERS THEN
              RAISE_APPLICATION_ERROR (-20001, 'Falha no cadastro de eventos agendveis.');
        END;
    END IF;
END;
/

DECLARE

-- VERSAO --
BEGIN ATUVEROBJ('ETL_PEDIDOS','0.00.000'); END;
/




